java - O Eclipse não pode carregar bibliotecas SWT




ubuntu unsatisfiedlinkerror (8)

Eu concordo com Scott, o que ele listou funcionou. No entanto, apenas executá-lo de qualquer diretório não funcionou. Eu tive que cd para os arquivos / home / * / .swt/lib/linux/x86_64/ 0

primeiro diretório e, em seguida, execute o comando link:

Para 32 bits:

ln -s /usr/lib/jni/libswt-* ~/.swt/lib/linux/x86/

E no Ubuntu 12,04 64 bit:

ln -s /usr/lib/jni/libswt-* ~/.swt/lib/linux/x86_64/

Toda vez que tento abrir o Eclipse no Ubuntu 12.04, recebo um erro de link insatisfatório e ele não abre. Eu instalei recentemente o Java JDK e Android SDK, isso poderia ser o problema? Eu segui este tutorial .

Aqui está a informação do log:

!SESSION 2012-04-15 21:05:46.902 -----------------------------------------------
eclipse.buildId=I20110613-1736
java.version=1.7.0
java.vendor=Oracle Corporation
BootLoader constants: OS=linux, ARCH=x86_64, WS=gtk, NL=en_GB
Command-line arguments:  -os linux -ws gtk -arch x86_64

!ENTRY org.eclipse.osgi 4 0 2012-04-15 21:05:47.885
!MESSAGE Application error
!STACK 1
java.lang.UnsatisfiedLinkError: Could not load SWT library. Reasons: 
no swt-gtk-3740 in java.library.path
no swt-gtk in java.library.path
Can't load library: /home/tom/.swt/lib/linux/x86_64/libswt-gtk-3740.so
Can't load library: /home/tom/.swt/lib/linux/x86_64/libswt-gtk.so

at org.eclipse.swt.internal.Library.loadLibrary(Library.java:285)
at org.eclipse.swt.internal.Library.loadLibrary(Library.java:194)
at org.eclipse.swt.internal.C.<clinit>(C.java:21)
at org.eclipse.swt.internal.Converter.wcsToMbcs(Converter.java:63)
at org.eclipse.swt.internal.Converter.wcsToMbcs(Converter.java:54)
at org.eclipse.swt.widgets.Display.<clinit>(Display.java:132)
at org.eclipse.ui.internal.Workbench.createDisplay(Workbench.java:695)
at org.eclipse.ui.PlatformUI.createDisplay(PlatformUI.java:161)
at org.eclipse.ui.internal.ide.application.IDEApplication.createDisplay(IDEApplication.java:153)
at org.eclipse.ui.internal.ide.application.IDEApplication.start(IDEApplication.java:95)
at org.eclipse.equinox.internal.app.EclipseAppHandle.run(EclipseAppHandle.java:196)
at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication(EclipseAppLauncher.java:110)
at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start(EclipseAppLauncher.java:79)
at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:344)
at org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:179)
at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)
at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:57)
at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)
at java.lang.reflect.Method.invoke(Method.java:601)
at org.eclipse.equinox.launcher.Main.invokeFramework(Main.java:622)
at org.eclipse.equinox.launcher.Main.basicRun(Main.java:577)
at org.eclipse.equinox.launcher.Main.run(Main.java:1410)
at org.eclipse.equinox.launcher.Main.main(Main.java:1386)

Eu tentei desinstalar e reinstalar e remover o diretório ~/.eclipse , mas ainda não funciona



No meu caso, eu estava faltando o /usr/lib/jni inteiramente. Corrigido por

sudo apt-get install libswt-gtk-3-jni libswt-gtk-3-java

Não há necessidade de ligar simbolicamente depois. O Eclipse começou normalmente.


No redhat7:

yum install gtk2 libXtst xorg-x11-fonts-Type1

fez o trabalho, por causa de uma dependência swt.

encontrado here


RESOLVIDO:

Como eu tinha instalado o Oracle Java 7, ele havia alterado o Java padrão para o Oracle Java 7, mas precisava ser o Open JDK.

Para consertar, abra o terminal e digite

sudo update-alternatives --config java

Isso traz uma lista dos diferentes tipos de Java. Basta selecionar o Open JDK.


Se você iniciar o eclipse usando oracle java, o Eclipse poderá falhar ao encontrar bibliotecas nativas como bibliotecas SWT ou SVN. As bibliotecas do SWT-JNI estão localizadas em / usr / lib / jni / e as bibliotecas do SVN-JNI estão localizadas em / usr / lib / x86_64-linux-gnu / jni /.

Em vez de iniciar o eclipse com o comando

eclipse

você pode usar o comando

env LD_LIBRARY_PATH=/usr/lib/jni/:/usr/lib/x86_64-linux-gnu/jni/:$LD_LIBRARY_PATH eclipse

para passar a variável de ambiente LD_LIBRARY_PATH para eclipse. O Eclipse encontrará as bibliotecas nativas e será executado corretamente.


Um método possivelmente mais genérico é:

  • instalar a versão não-headless do openjdk,
  • instalar, executar e fechar o eclipse.
  • desinstalar o openjdk
  • instalar o JDK do oracle

no meu Ubuntu 12,04 32 bit . Eu edito o comando para:

ln -s /usr/lib/jni/libswt-* ~/.swt/lib/linux/x86/

E no Ubuntu 12,04 64 bit tente:

ln -s /usr/lib/jni/libswt-* ~/.swt/lib/linux/x86_64/






unsatisfiedlinkerror